clear all
close all
%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                       %
%                       TRABAJO DE FIN DE GRADO                         %
%         MONITORIZACION DEL ESTADO Y RENDIMIENTO DE UNA PLANTA FV      %
%                       ANDRÉS BONILLA TORIBIO                          %
%                  PLANTA FOTOVOLTAICA EDIFICO LUCIA                    %
%                      UNIVERSIDAD DE VALLADOLID                        %
%                                                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% EN PRIMER LUGAR CARGO LOS FICHEROS

% FICHEROS DEL INVERSOR INGETEAM, DEL CAMPO SOLAR POLICRISTALINO
% 4 FICHEROS POR MES, MESES DE ENERO A OCTUBRE DE 2022

ficheroInv = {'1ExportAllVarplant20211231_20220107.xlsx', '1ExportAllVarplant20220107_20220114.xlsx','1ExportAllVarplant20220114_20220121.xlsx','1ExportAllVarplant20220121_20220128.xlsx','1ExportAllVarplant20220128_20220204.xlsx',...
    '1ExportAllVarplant20220204_20220211.xlsx','1ExportAllVarplant20220211_20220218.xlsx','1ExportAllVarplant20220218_20220225.xlsx','1ExportAllVarplant20220225_20220304.xlsx',...
    '1ExportAllVarplant20220304_20220311.xlsx', '1ExportAllVarplant20220311_20220318.xlsx', '1ExportAllVarplant20220318_20220325.xlsx', '1ExportAllVarplant20220325_20220401.xlsx',...
    '1ExportAllVarplant20220401_20220408.xlsx', '1ExportAllVarplant20220408_20220415.xlsx', '1ExportAllVarplant20220415_20220422.xlsx', '1ExportAllVarplant20220422_20220429.xlsx',...
    '1ExportAllVarplant20220429_20220506.xlsx', '1ExportAllVarplant20220506_20220513.xlsx', '1ExportAllVarplant20220513_20220520.xlsx', '1ExportAllVarplant20220520_20220527.xlsx',...
    '1ExportAllVarplant20220527_20220603.xlsx', '1ExportAllVarplant20220603_20220610.xlsx', '1ExportAllVarplant20220610_20220617.xlsx', '1ExportAllVarplant20220617_20220624.xlsx',...
    '1ExportAllVarplant20220624_20220701.xlsx', '1ExportAllVarplant20220701_20220708.xlsx', '1ExportAllVarplant20220708_20220715.xlsx', '1ExportAllVarplant20220715_20220722.xlsx',...
    '1ExportAllVarplant20220722_20220729.xlsx', '1ExportAllVarplant20220729_20220805.xlsx', '1ExportAllVarplant20220805_20220812.xlsx', '1ExportAllVarplant20220812_20220819.xlsx',...
    '1ExportAllVarplant20220819_20220826.xlsx', '1ExportAllVarplant20220826_20220902.xlsx', '1ExportAllVarplant20220902_20220909.xlsx', '1ExportAllVarplant20220909_20220916.xlsx',...
    '1ExportAllVarplant20220916_20220923.xlsx', '1ExportAllVarplant20220923_20220930.xlsx', '1ExportAllVarplant20220930_20221007.xlsx', '1ExportAllVarplant20221007_20221014.xlsx',...
    '1ExportAllVarplant20221014_20221021.xlsx', '1ExportAllVarplant20221021_20221028.xlsx', '1ExportAllVarplant20221028_20221031.xlsx'};


% FICHEROS DE LA ESTACION METEOROLÓGICA, DE ENERO A OCTUBRE DE 2022

ficheroEst ={'01_2022 estacion met.xlsx','02_2022 estacion met.xlsx','03_2022 estacion met.xlsx', '04_2022 estacion met.xlsx', '05_2022 estacion met'...
    '06_2022 estacion met.xlsx', '07_2022 estacion met.xlsx', '08_2022 estacion met.xlsx', '09_2022 estacion met.xlsx', '10_2022 estacion met.xlsx'};

% LEO LOS FICHEROS DE INGETEAM CON LA RUTA DE LA CARPETA DONDE SE ENCUENTRAN 

% CONVIERTO LOS DATOS DEL EXCEL POR FECHAS

datosInversorIng = cell(1, length(ficheroInv));
fechasInversorIng = cell(1, length(ficheroInv));

rutaInversor = 'C:\Users\anbot\OneDrive\Documentos\TRABAJO DE FIN DE GRADO\Matlab\Prueba TFG\TFG MONITORIZACION'; % Actualizar la ruta del directorio

for i = 1:length(ficheroInv)
    InversorIngeteam = fullfile(rutaInversor, ficheroInv{i});
    datosInversorIng{i} = readmatrix(InversorIngeteam);
    fechasInversorIng{i} = datetime(datosInversorIng{i}(:, 3), 'ConvertFrom', 'excel');
end


% LEO LOS FICHEROS DE LA ESTACIÓN METEOROLÓGICA, TAMBIEN CON LA CARPETA Y
% CONVIERTO DATOS

datosEstacionMet = cell(1, length(ficheroEst));
fechasEstacionMet = cell(1, length(ficheroEst));

rutaEstacionMet = 'C:\Users\anbot\OneDrive\Documentos\TRABAJO DE FIN DE GRADO\Matlab\Prueba TFG\TFG MONITORIZACION'; % Actualizar la ruta del directorio

for i = 1:length(ficheroEst)
    EstacionMet = fullfile(rutaEstacionMet, ficheroEst{i});
    datosEstacionMet{i} = readmatrix(EstacionMet);
    fechasEstacionMet{i} = datetime(datosEstacionMet{i}(:, 1), 'ConvertFrom', 'excel');
end

% UNA VEZ HE CARGADO Y LEIDO LOS DATOS, PIDO AL USUARIO QUE INTRODUZCA LAS
% FECHAS EN EL PERIODO DE TIEMPO QUE QUIERE VISUALIZAR

InicioStr= input('Introduce la fecha inicial (formato: dd/MM/yyyy HH:mm ): ', 's');
FechaInicio = datetime(InicioStr, 'InputFormat', 'dd/MM/yyyy HH:mm');

FinalStr = input('Introduce la fecha final (formato: dd/MM/yyyy HH:mm): ', 's');
FechaFinal = datetime(FinalStr,'InputFormat', 'dd/MM/yyyy HH:mm');


% OBTENGO EL NUMERO DE LAS FILAS DEL EXCEL, O LOS INDICES DEL INVERSOR Y DE
% LA ESTACION METEOROLOGICA COMPRENDIDAS ENTRE LAS FECHAS, INCLUIDAS ESTAS

IndiceInv = cell(1, length(fechasInversorIng));
for i = 1:length(fechasInversorIng)
    fechas = fechasInversorIng{i};
    indices = find(fechas >= FechaInicio & fechas <= FechaFinal);
    IndiceInv{i} = indices+1;
end


IndiceEst = cell(1, length(fechasEstacionMet));
for i = 1:length(fechasEstacionMet)
    fechas = fechasEstacionMet{i};
    indices = find(fechas >= FechaInicio & fechas <= FechaFinal);
    IndiceEst{i} = indices;
   
end



% A MODO DE EJEMPLO MUESTRO LAS FILAS COMPRENDIDAS EN EL EXCEL DEL INVERSOR
% Y EN EL EXCEL DE LA ESTACION, INDICANDO EL NUMERO DE FICHERO EN EL QUE HA
% ENTRADO

%fprintf('Filas comprendidas entre las fechas para el inversor en el fichero:\n');
%celldisp(IndiceInv);
%fprintf('Filas comprendidas entre las fechas para la estación meteorológica:\n');
%celldisp(IndiceEst);

% EN ESTE APARTADO, FILTRO LAS FILAS ESCOGIDASPARA QUE SOLO APAREZCAN
% AQUELLAS ENTRE LAS 9:00 Y LAS 17:30, JUNTO CON QUE ACABEN EN 00 Y 30,
% PARA QUE COINCIDAN EL NUMERO DE DATOS EN LOS ARRAYS PARA EL CALCULO.

% FILTRO LOS INDICES CON MINUTOS 00 Y 30 Y CON HORAS DE 9 A 17 DEL FICHERO DEL INVERSOR

IndiceInvFiltrado = cell(size(IndiceInv));
for i = 1:length(IndiceInv)
    indices = IndiceInv{i}-1;
    fechas = fechasInversorIng{i};
    indicesFiltrados = indices((minute(fechas(indices)) == 0 | minute(fechas(indices)) == 30) & (hour(fechas(indices)) >= 9 & hour(fechas(indices)) <= 17));
    IndiceInvFiltrado{i} = indicesFiltrados+1;
end

% FILTRO LOS INDICES CON MINUTOS 00 Y 30 Y CON HORAS DE 9 A 17 DEL FICHERO DEL INVERSOR

IndiceEstFiltrado = cell(size(IndiceEst));
for i = 1:length(IndiceEst)
    indices = IndiceEst{i};
    fechas = fechasEstacionMet{i};
    indicesFiltrados = indices((minute(fechas(indices)) == 0 | minute(fechas(indices)) == 30) & (hour(fechas(indices)) >= 9 & hour(fechas(indices)) <= 17));
    IndiceEstFiltrado{i} = indicesFiltrados;
end

% MUESTRO INDICES FILTRADOS

%celldisp(IndiceInvFiltrado);
%celldisp(IndiceEstFiltrado);


% UNA VEZ TENGO LOS INDICES FILTRADOS, ALMACENO LOS DATOS FILTRADOS DEL
% INVERSOR EN LA TABLA DEL INVERSOR

fprintf('Datos del inversor de ingeteam mostrando los parametros: \n');
alarma = false;
for i = 1:length(IndiceInvFiltrado)
    indices = IndiceInvFiltrado{i}-1;
    datosInversor = datosInversorIng{i}; 
    tablaInversor = table();
    fechasInvstr = fechasInversorIng{i}(indices);
    fechasInvString = datestr(fechasInvstr, 'dd/mm/yyyy HH:MM');
    
    
    for j = 1:length(indices)
        filas = indices(j);
        
        Vac1 = datosInversor(filas, 5);
        Vac2 = datosInversor(filas, 6);
        Vac3 = datosInversor(filas, 7);
        Iac1 = datosInversor(filas, 8);
        Iac2 = datosInversor(filas, 9);
        Iac3 = datosInversor(filas, 10);
        Freq = datosInversor(filas, 11);
        PacI = datosInversor(filas, 12);
        QacI = datosInversor(filas, 13);
        cosF = datosInversor(filas, 14);
        Vdc1 = datosInversor(filas, 15);
        Idc1 = datosInversor(filas, 16);
        Pdc1 = datosInversor(filas, 17);
        PacGrid = datosInversor(filas, 18);
        Energy = datosInversor(filas, 19);


         filaTabla = table(  Vac1 , Vac2, Vac3, Iac1, Iac2, Iac3, Freq, PacI, QacI, cosF, Vdc1, Idc1, Pdc1, PacGrid, Energy);
        tablaInversor = [tablaInversor; filaTabla];

         % Comprobar si Vac1 está fuera del rango deseado y mostrar una alarma
        if Vdc1 < 560 || Vdc1 > 1000
            fprintf('¡ALARMA! Vdc1 está fuera del rango. Valor actual: %.2f V\n', Vdc1);
            alarma=true;
        end
        
        if Idc1 > 11
            fprintf('¡ALARMA! Idc1 está fuera del rango. Valor actual: %.2f V\n', Idc1);
            alarma=true;
        end
        
    end
    fprintf('tabla del Inversor %d:\n', i);
    disp(tablaInversor);

    disp(fechasInvString); 
end
 
% LEO Y ALMACENO LOS DATOS FILTRADOS DE LA ESTACION EN OTRA TABLA

fprintf('Datos de la Estacion Meteorológica: \n');
for i = 1:length(IndiceEstFiltrado)
    indices = IndiceEstFiltrado{i};
    
    datosEstacion = datosEstacionMet{i}; 
    tablaEstacion = table();
    fechasEststr = fechasEstacionMet{i}(indices);

    fechasEstString = datestr(fechasEststr, 'dd/mm/yyyy HH:MM');
    
    for j = 1:length(indices)
        filas = indices(j);
        
        v_viento_med = datosEstacion(filas, 2);
        d_viento_med = datosEstacion(filas, 5);
        temp_med = datosEstacion(filas, 8);
        hum_rel_med = datosEstacion(filas, 11);
        presion_med = datosEstacion(filas, 12);
        R_global1_med = datosEstacion(filas, 13);
        R_global2_med = datosEstacion(filas, 15);
        Fotometro1_med = datosEstacion(filas, 17);
        Fotometro2_med = datosEstacion(filas, 19);
        Fotometro3_med = datosEstacion(filas, 21);
        Fotometro4_med = datosEstacion(filas, 23);
        Lluvia_med = datosEstacion(filas, 31);
        V_bateria_med = datosEstacion(filas, 32);
        V_bateria_max = datosEstacion(filas, 33);
        V_bateria_min = datosEstacion(filas, 34);



        filaTabla = table( v_viento_med, temp_med, R_global1_med, R_global2_med);
        tablaEstacion = [tablaEstacion; filaTabla];



    end 
    fprintf('Tabla de la Estación %d:\n', i);
    disp(tablaEstacion);

    disp(fechasEstString);
end

% HASTA AQUI ME DA BIEN LOS DATOS EN LA TABLA, PERO ME DA PROBLEMAS SI
% AÑADO LAS FECHAS Y LAS FECHAS ME LAS LEE CON UN DIA MAS, PERO LSO DATOS
% DE LA TABLA ESTÁN BIEN.

% AQUI YA TENGO SELECCIONADOS LAS FILAS O INDICES EN LOS QUE COINCIDEN.

% EN ESTE PUNTO VOY A LEER LOS DATOS DEL INVERSOR QUE QUIERO ANALIZAR
% DE IGUAL FORMA CON LOS DATOS DE LA ESTACIÓN METEOROLÓGICA
% 
% datosPacI = [];
% datosPdc1 = [];
% datosVdc1 = [];
% datosIdc1 = [];
% datosTempMedia = [];
% datosRadiacion = [];
% datosRglobal2 = [];

% % OBTENGO DATOS DE PDC1 DEL INVERSOR, Y VDC1 E IDC1
% 
% for i = 1:length(IndiceInvFiltrado)
%     indices = IndiceInvFiltrado{i}-1;
%     datosInversor = datosInversorIng{i};
% 
%     pacI = datosInversor(indices, 12);
%     pdc1 = datosInversor(indices, 17);
%     vdc1 = datosInversor(indices, 15);
%     idc1 = datosInversor(indices, 16);
% 
%     datosPacI = [datosPacI; pacI];
%     datosPdc1 = [datosPdc1; pdc1];
%     datosVdc1 = [datosVdc1; vdc1];
%     datosIdc1 = [datosIdc1; idc1];
% end
% 
% % OBTENGO DATOS DE TEMPERATURA Y RADIACION DE LA ESTACIÓN METEOROLÓGICA
% 
% for i = 1:length(IndiceEstFiltrado)
%     indices = IndiceEstFiltrado{i};
%     datosEstacion = datosEstacionMet{i};
% 
%     tempMedia = datosEstacion(indices, 8);  
%     radiacion = datosEstacion(indices, 13);
%     rglobal2 = datosEstacion(indices, 15);
% 
%     datosTempMedia = [datosTempMedia; tempMedia];
%     datosRadiacion = [datosRadiacion; radiacion];
%     datosRglobal2 = [datosRglobal2; rglobal2];
% end

% CREO TABLA PARA GUARDAR LOS DATOS

tablaDatosInv = table();
tablaDatosEst = table();

% AGREGO LOS DATOS DEL INVERSOR A LA TABLA
for i = 1:length(IndiceInvFiltrado)
    indicesInv = IndiceInvFiltrado{i} - 1;
    datosInversor = datosInversorIng{i};

    pacI = datosInversor(indicesInv, 12);
    pdc1 = datosInversor(indicesInv, 17); 
    vdc1 = datosInversor(indicesInv, 15);
    idc1 = datosInversor(indicesInv, 16);
    iac1 = datosInversor(indicesInv, 8);
    iac2 = datosInversor(indicesInv, 9);
    iac3 = datosInversor(indicesInv, 10);
    vac1 = datosInversor(indicesInv, 5);
    vac2 = datosInversor(indicesInv, 6);
    vac3 = datosInversor(indicesInv, 7);

    %fechasInvDouble = datosInversor(indicesInv, 3);  % Fechas en la tercera columna del inversor como doubles
    fechasInvstr = fechasInversorIng{i}(indicesInv);

    % CONVIERTO FECHAS EN STRING A FORMATO DOUBLE "dd/mm/AAAA HH:mm"
    fechasInvString = datestr(fechasInvstr, 'dd/mm/yyyy HH:MM');  % Fecha de la columna 3 de los índices filtrados del inversor

    % AGREGO DATOS
    tablaDatosInv = [tablaDatosInv; table(indicesInv+1, fechasInvString , pdc1, vdc1, idc1, pacI, iac1, iac2, iac3, vac1, vac2, vac3)];
end

% AGREGO LOS DATOS DE LA ESTACION A LA TABLA

for i = 1:length(IndiceEstFiltrado)
    indicesEst = IndiceEstFiltrado{i};
    datosEstacion = datosEstacionMet{i};
    tempMedia = datosEstacion(indicesEst, 8); 
    radiacion = datosEstacion(indicesEst, 13); 
    rglobal2 = datosEstacion(indicesEst, 15);

    
    
    fechasEststr = fechasEstacionMet{i}(indicesEst);
    fechasEstString = datestr(fechasEststr, 'dd/mm/yyyy HH:MM');  % Fecha de la columna 3 de los índices filtrados del inversor

    tablaDatosEst = [tablaDatosEst; table(indicesEst, fechasEstString , radiacion, rglobal2 ,tempMedia)];
    
end

% ASIGNO NOMBRE A LAS VARIABLES DE LAS COLUMNAS DE LAS TABLAS

tablaDatosInv.Properties.VariableNames = {'IndiceInvFiltrado', 'FechaInversor', 'Pdc1_W', 'Vdc1_V', 'Idc1_A', 'PacI_W',...
                                           'Iac1_A', 'Iac2_A', 'Iac3_A', 'Vac1_V', 'Vac2_V', 'Vac3_V'};
tablaDatosEst.Properties.VariableNames = {'IndiceEstFiltrado', 'FechaEstacion', 'Radiacion', 'Radiacion2', 'Temperatura'};

%MUESTRO TABLAS

disp(tablaDatosInv);
disp(tablaDatosEst);

% HASTA AQUI ME ENCUENTRA BIEN LOS DATOS PERO A LAS FECHAS LES DA UN DIA
% MAS

% HASTA AQUI ME ENCUENTRA TODOS LOS DATOS Y ME HACE LA TABLA CON TODOS LOS
% DATOS, PERO AHORA QUIERO FILTRAR PARA QUE SOLO SAQUE, TANTO DEL INVERSOR
% COMO DE LA ESTACION , SOLO LOS DATOS COMPRENDIDOS ENTRE LAS 9 DE LA
% MAÑANA Y LAS 18 DE LA TARDE he añadido codigo arriba para ello 

% YA TENGO SELECCIONADOS LOS DATOS QUE ME INTERESAN ENTRE ESAS HORAS

% REALIZO CALCULOS CON LAS VARIABLES DE LAS TABLAS

%DEFINO LAS VARIABLES QUE UTILIZARE EN CALCULOS

Tempcelula = [];
Tempcelula2 = [];

Pmax = [];
Pmax2 = [];

PdcTeorica = [];
PdcTeorica2 = [];

PDCPANEL = [];
PDCPANEL2 = [];

Rendi = [];
Rendi2 = [];

NOCTTsharp = 45;
NOCTIrrad = 800;
NOCTTvien = 20;
Ktemp = (-0.39)/100;
Pstc = 330;
Gstc = 1000;
Tstc = 25;
NumPaneles = 20;
AreaPanel = 1.94;
RendPanel = 0.17;
KSilicio = -0.0035;

%CALCULO LA TEMPERATURA DE LA CELULA PASANDO LINEA POR LINEA POR LOS DATOS
%DE LA TABLA
% TEMPERATURA DE CELULA POR MODELO EN CONDICIONES NORMALES DE OPERACION
% NOCT

Tempcelula = tablaDatosEst.Temperatura + (((NOCTTsharp-NOCTTvien)*(tablaDatosEst.Radiacion ))/NOCTIrrad);

if min(Tempcelula) < (-40) ||  max(Tempcelula) > 85
            fprintf('¡ALARMA! Temperatura de celula está fuera del rango. Valor actual: %.2f V\n', Tempcelula);
            alarma=true;
end


Tempcelula2 = tablaDatosEst.Temperatura + (((NOCTTsharp-NOCTTvien)*(tablaDatosEst.Radiacion2 ))/NOCTIrrad);

if min(Tempcelula2) < (-40) ||  max(Tempcelula2) > 85
            fprintf('¡ALARMA! Temperatura de celula segun radiacion 2 está fuera del rango. Valor actual: %.2f V\n', Tempcelula2);
            alarma=true;
end

% CALCULO LA POTENCIA SEGUN LA TEMPERATURA DE LA 

Pmax =  Pstc * (tablaDatosEst.Radiacion / Gstc) .* ((1 + (Ktemp) * (Tempcelula  - Tstc)));
PdcTeorica  = Pmax*NumPaneles; 

Pmax2 =  Pstc * (tablaDatosEst.Radiacion2 / Gstc) .* ((1 + (Ktemp) * (Tempcelula2  - Tstc)));
PdcTeorica2  = Pmax2*NumPaneles; 

% Y CALCULO EL RENDIMIENTO DE LA OPERACION COMPARANDO LA PDC TEORICA CON LA
% PDC1 DEL INVERSOR

rendimiento = (tablaDatosInv.Pdc1_W ./ PdcTeorica);

rendimiento2 = (tablaDatosInv.Pdc1_W ./ PdcTeorica2);

% AHORA UTILIZO OTRO MODELO EN FUNCION DE LA VARIACION DE LA RADIACIÓN Y LA
% TEMPERATURA 

%DEFINO EL RENDIMIENTO EN CONDICIONES OPTIMAS

Rendi = RendPanel .* (1+(KSilicio)*(Tempcelula-Tstc));

Rendi2 = RendPanel .* (1+(KSilicio)*(Tempcelula2-Tstc));

% Y CALCULO LA POTENCIA DEL PANEL EN FUNCION DEL AREA RECEPTOR

PDCPANEL = (AreaPanel .* tablaDatosEst.Radiacion .* Rendi)* NumPaneles; 

PDCPANEL2 = (AreaPanel .* tablaDatosEst.Radiacion2 .* Rendi)* NumPaneles; 

% CALCULO EL RENDIMIENTO DE LA INSTALACION SEGUN EL SEGUNDO METODO

REND1 = (tablaDatosInv.Pdc1_W ./ PDCPANEL);

REND2 = (tablaDatosInv.Pdc1_W ./ PDCPANEL2);

% AÑADO COLUMNAS A LAS TABLAS CON LOS DATOS CALCULADOS

tablaDatosInv.PdcTeorica_W = PdcTeorica;
tablaDatosInv.PmaxTeorica_W = Pmax;
tablaDatosEst.TemperaturaCelula = Tempcelula;
tablaDatosInv.Rendimiento = rendimiento;
tablaDatosInv.PDCPANEL_W = PDCPANEL;
tablaDatosInv.RENDIMIENTO = REND1;

tablaDatosInv.PdcTeorica2_W = PdcTeorica2;
tablaDatosInv.PmaxTeorica2_W = Pmax2;
tablaDatosEst.TemperaturaCelula2 = Tempcelula2;
tablaDatosInv.Rendimiento2 = rendimiento2;
tablaDatosInv.PDCPANEL2_W = PDCPANEL2;
tablaDatosInv.RENDIMIENTO2 = REND2;

% MUESTRO LAS TABLAS RESULTANETES CON LA NUEVAS COLUMNAS

disp(tablaDatosInv);
disp(tablaDatosEst);

% EN ESTE APARTADO RECOGO LOS DATOS DE LA TABLA QUE QUIERO GRAFICAR, EN
% ESTE CASO EL RENDIMEINTO Y LA POTENCIA TEORICA DEL PRIMER MODELO, JUNTO
% CON LA PDC1 DEL INVERSOR

datosPacI = tablaDatosInv.PacI_W;
datosPdc1 = tablaDatosInv.Pdc1_W;
datosVdc1 = tablaDatosInv.Vdc1_V;
datosIdc1 = tablaDatosInv.Idc1_A;

datosVac1 = tablaDatosInv.Vac1_V;
datosVac2 = tablaDatosInv.Vac2_V;
datosVac3 = tablaDatosInv.Vac3_V;

datosIac1 = tablaDatosInv.Iac1_A;
datosIac2 = tablaDatosInv.Iac2_A;
datosIac3 = tablaDatosInv.Iac3_A;

datosRendimiento = tablaDatosInv.Rendimiento;
datosRENDIMIENTO = tablaDatosInv.RENDIMIENTO;
datosPdcTeorica = tablaDatosInv.PdcTeorica_W;
datosPDCPANEL = tablaDatosInv.PDCPANEL_W;

datosRendimiento2 = tablaDatosInv.Rendimiento2;
datosPdcTeorica2 = tablaDatosInv.PdcTeorica2_W;
datosPDCPANEL2 = tablaDatosInv.PDCPANEL2_W;
datosRENDIMIENTO2 = tablaDatosInv.RENDIMIENTO2;

fechasDouble = datenum(tablaDatosInv.FechaInversor, 'dd/mm/yyyy HH:MM');

% GRAFICO CORRIENTES TRIFÁSICAS

figure;
plot(fechasDouble, datosIac1, 'b-', 'LineWidth', 1.5);
hold on;
plot(fechasDouble, datosIac2, 'r-', 'LineWidth', 1.5);
hold on;
plot(fechasDouble, datosIac3, 'm-', 'LineWidth', 1.5);
hold off;
% datetick('x', 'dd/mm/yyyy HH:MM', 'keeplimits');
datetick('x', 'dd/mm/yyyy HH:MM', 'keeplimits', 'keepticks');
xlabel('Fechas escogidas');
ylabel('Amperios');
title('Corrientes trifasicas');
legend('Iac1', 'Iac2', 'Iac3');

% GRAFICO TENSIONES TRIFÁSICAS

figure;
plot(fechasDouble, datosVac1, 'b-', 'LineWidth', 1.5);
hold on;
plot(fechasDouble, datosVac2, 'r-', 'LineWidth', 1.5);
hold on;
plot(fechasDouble, datosVac3, 'm-', 'LineWidth', 1.5);
hold off;
% datetick('x', 'dd/mm/yyyy HH:MM', 'keeplimits');
datetick('x', 'dd/mm/yyyy HH:MM', 'keeplimits', 'keepticks');
xlabel('Fechas escogidas');
ylabel('Voltios');
title('Tensiones trifasicas');
legend('Vac1', 'Vac2', 'Vac3');


% GRAFICO DATOS EN CONTINUA

figure;
plot(fechasDouble, datosPdc1, 'b-', 'LineWidth', 1.5);
hold on;
plot(fechasDouble, datosVdc1, 'r-', 'LineWidth', 1.5);
hold off;
% datetick('x', 'dd/mm/yyyy HH:MM', 'keeplimits');
datetick('x', 'dd/mm/yyyy HH:MM', 'keeplimits', 'keepticks');
xlabel('Fechas escogidas');
ylabel('Potencia DC (W) y Tension DC (V)');
title('Potencia DC (W) y Tension DC (V) del inversor');
legend('Pdc1', 'Vdc1');

figure;
plot(fechasDouble, datosIdc1, 'y-', 'LineWidth', 1.5);
hold off;
datetick('x', 'dd/mm/yyyy HH:MM', 'keeplimits', 'keepticks');
xlabel('Fechas');
ylabel('Çorriente DC (A)');
title('Corriente DC del inversor');
legend('Idc1');


% GRAFICO LOS DATOS DE PDC1, PacInversor, RENDIMIENTO , PDC PANEL Y PDC TEORICA

figure;
plot(fechasDouble, datosPdc1, 'b-', 'LineWidth', 1.5);  % Grafico Pdc1 en azul
hold on;
plot(fechasDouble, datosPacI, 'm-', 'LineWidth', 1.5); % Grafico dr Pac inversor
hold on;
plot(fechasDouble, datosPdcTeorica, 'r-', 'LineWidth', 1.5);  % Grafico PdcTeorica en rojo
hold on;
plot(fechasDouble, datosPDCPANEL, 'y-', 'LineWidth', 1.5); % Grafico Potencia del panel en amarillo
hold off;
datetick('x', 'dd/mm/yyyy HH:MM', 'keeplimits', 'keepticks');
xlabel('Fechas');
ylabel('Potencias Reales y Teoricas en W segun radiacion 1');
title('Comparacion entre Potencias segun Radiacion Global 1');
legend('Pdc1', 'PacInverosr', 'PdcTeorica', 'PDC panel');

figure;
plot(fechasDouble, datosRendimiento);
datetick('x', 'dd/mm/yyyy HH:MM', 'keeplimits', 'keepticks');
xlabel('Fechas');
ylabel('Rendimiento segun radiacion global 1');
title('Rendimiento segun temperatura y radiacion global 1');

figure;
plot(fechasDouble, datosRENDIMIENTO);
datetick('x', 'dd/mm/yyyy HH:MM', 'keeplimits', 'keepticks');
xlabel('Fechas');
ylabel('Rendimiento del metodo 2 segun radiacion global 1');
title('Rendimiento segun temperatura y radiacion global 1');

% HAGO LA COMPARACION SEGUN LA RADIACION GLOBAL 2

figure;
plot(fechasDouble, datosPdc1, 'b-', 'LineWidth', 1.5);  % Grafico Pdc1 en azul
hold on;
plot(fechasDouble, datosPacI, 'm-', 'LineWidth', 1.5); % Grafico dr Pac inversor
hold on;
plot(fechasDouble, datosPdcTeorica2, 'r-', 'LineWidth', 1.5);  % Grafico PdcTeorica en rojo
hold on;
plot(fechasDouble, datosPDCPANEL2, 'y-', 'LineWidth', 1.5); % Grafico Potencia del panel en amarillo
hold off;
datetick('x', 'dd/mm/yyyy HH:MM', 'keeplimits', 'keepticks');
xlabel('Fechas');
ylabel('Potencias Reales y Teoricas en W segun radiacion 2');
title('Comparacion entre Potencias segun Radiacion Global 2 ');
legend('Pdc1', 'Pac Inversor', 'PdcTeorica', 'PdcPanel');

figure;
plot(fechasDouble, datosRendimiento2);
datetick('x', 'dd/mm/yyyy HH:MM', 'keeplimits', 'keepticks');
xlabel('Fechas');
ylabel('Rendimiento en funcion de la radiacion 2');
title('Rendimiento segun temperatura y radiacion global 2');

figure;
plot(fechasDouble, datosRENDIMIENTO2);
datetick('x', 'dd/mm/yyyy HH:MM', 'keeplimits', 'keepticks');
xlabel('Fechas');
ylabel('Rendimiento del metodo 2 en funcion de la radiacion 2');
title('Rendimiento segun temperatura y radiacion global 2');

figure; 
plot(fechasDouble, datosRendimiento, 'b-', 'LineWidth', 1.5);
hold on;
plot(fechasDouble, datosRendimiento2, 'r-', 'LineWidth', 1.5);
hold off;
datetick('x', 'dd/mm/yyyy HH:MM', 'keeplimits', 'keepticks');
xlabel('Fechas');
ylabel('Rendimiento');
title('Comparacion de rendimientos del metodo 1 entre radiacion global 1 y 2 ');
legend('Rend rad global 1', 'Rend rad global 2');

figure; 
plot(fechasDouble, datosRENDIMIENTO, 'b-', 'LineWidth', 1.5);
hold on;
plot(fechasDouble, datosRENDIMIENTO2, 'r-', 'LineWidth', 1.5);
hold off;
datetick('x', 'dd/mm/yyyy HH:MM', 'keeplimits', 'keepticks');
xlabel('Fechas');
ylabel('Rendimiento');
title('Comparacion de rendimientos del metodo 2 entre radiacion global 1 y 2 ');
legend('Rend rad global 1', 'Rend rad global 2');

% COMPARO AHORA LOS DATOS ENTRE LA RADIACION GLOBAL 1 Y LA RADIACION 2

figure;
plot(fechasDouble, datosPdc1, 'b-', 'LineWidth', 1.5);  % Grafico Pdc1 en azul
hold on;
plot(fechasDouble, datosPacI, 'm-', 'LineWidth', 1.5); % Grafico dr Pac inversor
hold on;
plot(fechasDouble, datosPdcTeorica, 'g-', 'LineWidth', 1.5);  % Grafico PdcTeorica en verde
hold on;
plot(fechasDouble, datosPdcTeorica2, 'r-', 'LineWidth', 1.5);  % Grafico PdcTeorica rad2 en rojo
hold on;
plot(fechasDouble, datosPDCPANEL, 'k-', 'LineWidth', 1.5); % Grafico Potencia del panel en negro
hold on;
plot(fechasDouble, datosPDCPANEL2, 'y-', 'LineWidth', 1.5); % Grafico Potencia del panel rad2 en amarillo
hold off;
datetick('x', 'dd/mm/yyyy HH:MM', 'keeplimits', 'keepticks');
xlabel('Fechas');
ylabel('Potencias Reales y Teoricas en W segun radiacion 1 y 2');
title('Comparacion entre Potencias segun Radiacion Global 1 y 2 ');
legend('Pdc1', 'Pac Inversor', 'PdcTeorica','PdcTeorica2', 'PdcPanel', 'PdcPanel2');

% AHORA MUESTRO SI HA SALTADO ALGUNA ALARMA
 
if alarma
    fprintf('Se han detectado alarmas durante la ejecución del código.\n');
    fprintf('Por favor, revise los registros para más detalles.\n');
else
    fprintf('No se han detectado alarmas durante la ejecución del código.\n');
end

%%

% EN ESTE PUNTO SE GRAFICAN TODOS LOS DATOS RECOGIDOS ENTRE LAS FECHAS
% ESCOGIDAS PERO SIN FILTROS, ESCOGIENDO CADA UNA DE LAS FILAS, POR LO QUE
% A PARTIR DE AQUI NO SE PUEDEN HACER CALCULOS PORQUE NO VAN A TENER EL
% MISMO NUMERO DE FILAS Y COLUMNAS

% DEFINO LOS VECTORES DE LSO DATOS DEL INVERSOR

Pdc1graf = [];
Vac1graf = [];
Vac2graf = [];
Vac3graf = [];
Iac1graf = [];
Iac2graf = [];
Iac3graf = [];
Vdc1graf = [];
Idc1graf = [];
Freqgraf = [];
PacIgraf = [];
QacIgraf = [];
cosFgraf = [];
PacGridgraf = [];
Energygraf = [];

% ALMACENO LAS VARIABLES EN LOS VECTORES CORRESPONIDENTES

for i = 1:length(IndiceInv)
    indices = IndiceInv{i};
    datosInversor = datosInversorIng{i};
    
    for j = 1:length(indices)
        filas = indices(j)-1;
        
        Vac1graf = [Vac1graf; datosInversor(filas, 5)];
        Vac2graf = [Vac2graf; datosInversor(filas, 6)];
        Vac3graf = [Vac3graf; datosInversor(filas, 7)];
        Iac1graf = [Iac1graf; datosInversor(filas, 8)];
        Iac2graf = [Iac2graf; datosInversor(filas, 9)];
        Iac3graf = [Iac3graf; datosInversor(filas, 10)];
        Freqgraf = [Freqgraf; datosInversor(filas, 11)];
        PacIgraf = [PacIgraf; datosInversor(filas, 12)];
        QacIgraf = [QacIgraf; datosInversor(filas, 13)];
        cosFgraf = [cosFgraf; datosInversor(filas, 14)];
        Vdc1graf = [Vdc1graf; datosInversor(filas, 15)];
        Idc1graf = [Idc1graf; datosInversor(filas, 16)];
        Pdc1graf = [Pdc1graf; datosInversor(filas, 17)];
        PacGridgraf = [PacGridgraf; datosInversor(filas, 18)];
        Energygraf = [Energygraf; datosInversor(filas, 19)];

    end
end



% VARIABLES CONTINUAS

indicePdc1 = 1:length(Pdc1graf);
indiceVdc1 = 1:length(Vdc1graf);
indiceIdc1 = 1:length(Idc1graf);
figure;
plot(indicePdc1, Pdc1graf, 'g', indiceVdc1, Vdc1graf, 'r', indiceIdc1, Idc1graf, 'b');
xlabel('Índice');
ylabel('Pdc1, Vdc1, Idc1');
title('Gráfico de Variables en continua');

% TENSIONES TRIFASICAS

indiceVac1 = 1:length(Vac1graf);
indiceVac2 = 1:length(Vac2graf);
indiceVac3 = 1:length(Vac3graf);
figure;
plot(indiceVac1, Vac1graf,'g', indiceVac2, Vac2graf,'r', indiceVac3, Vac3graf,'b');
xlabel('Índice');
ylabel('Vac1, Vac2, Vac3');
title('Gráfico de Tensiones Trifásicas');

% CORRIENTES TRIFASICAS

indiceIac1 = 1:length(Iac1graf);
indiceIac2 = 1:length(Iac2graf);
indiceIac3 = 1:length(Iac3graf);
figure;
plot(indiceIac1, Iac1graf,'g', indiceIac2, Iac2graf,'r', indiceIac3, Iac3graf,'b');
xlabel('Índice');
ylabel('Iac1, Iac2, Iac3');
title('Gráfico de Corrientes Trifásicas');

% POTENCIAS Y ENERGIA 

indicePacI = 1:length(PacIgraf);
indicePacGrid = 1:length(PacGridgraf);
indiceEnergy = 1:length(Energygraf);
figure;
plot(indicePacI, PacIgraf,'g', indicePacGrid, PacGridgraf,'b', indiceEnergy,Energygraf*10^3, 'm' );
xlabel('Índice');
ylabel('PacI, QacI, PacGrid, Energy');
title('Gráfico de Potencias en Alterna y Energia');

% POTENCIA REACTIVA

indiceQacI = 1:length(QacIgraf);
figure;
plot(indiceQacI, QacIgraf,'r');
xlabel('Índice');
ylabel('QacI');
title('Gráfico de Potencia Reactiva');

% FACTOR DE POTENCIA

indiceCosF = 1:length(cosFgraf);
figure;
plot(indiceCosF,cosFgraf);
xlabel('Índice');
ylabel('Factor de Potencia CosF');
title('Gráfico de Variacion de Factor de potencia');

% FRECUENCIA

indiceFreq = 1:length(Freqgraf);
figure;
plot(indiceFreq,Freqgraf);
xlabel('Índice');
ylabel('Frecuencia de red');
title('Gráfico de Frecuencia de Red');

% LO MISMO CON LA ESTACION METEOROLÓGICA

% CREO VECTORES

v_viento_med_graf   = [];
d_viento_med_graf   = [];
temp_med_graf       = [];
hum_rel_med_graf    = [];
presion_med_graf    = [];
R_global1_med_graf  = [];
R_global2_med_graf  = [];
Fotometro1_med_graf = [];
Fotometro2_med_graf = [];
Fotometro3_med_graf = [];
Fotometro4_med_graf = [];
Lluvia_med_graf     = [];
V_bateria_med_graf  = [];
V_bateria_max_graf  = [];
V_bateria_min_graf  = [];

% ALMACENO DATOS EN LOS VECTORES

for i =1: length(IndiceEst)
    indices = IndiceEst{i};
    datosEstacion = datosEstacionMet{i};
    
    for j = 1:length(indices)
        filas = indices(j);

        v_viento_med_graf   = [v_viento_med_graf; datosEstacion(filas, 2)];
        d_viento_med_graf   = [d_viento_med_graf; datosEstacion(filas, 5)];
        temp_med_graf       = [temp_med_graf; datosEstacion(filas, 8)];
        hum_rel_med_graf    = [hum_rel_med_graf; datosEstacion(filas, 11)];
        presion_med_graf    = [presion_med_graf; datosEstacion(filas, 12)];
        R_global1_med_graf  = [R_global1_med_graf; datosEstacion(filas, 13)];
        R_global2_med_graf  = [R_global2_med_graf; datosEstacion(filas, 15)];
        Fotometro1_med_graf = [Fotometro1_med_graf; datosEstacion(filas, 17)];
        Fotometro2_med_graf = [Fotometro2_med_graf; datosEstacion(filas, 19)];
        Fotometro3_med_graf = [Fotometro3_med_graf; datosEstacion(filas, 21)];
        Fotometro4_med_graf = [Fotometro4_med_graf; datosEstacion(filas, 23)];
        Lluvia_med_graf     = [Lluvia_med_graf; datosEstacion(filas, 31)];
        V_bateria_med_graf  = [V_bateria_med_graf; datosEstacion(filas, 32)];
        V_bateria_max_graf  = [V_bateria_max_graf; datosEstacion(filas, 33)];
        V_bateria_min_graf  = [V_bateria_min_graf; datosEstacion(filas, 34)];
    end

end

% GRAFICOS DE DATOS OBTENIDOS

% RADIACION 1 Y 2 MEDIAS GLOBALES

indiceRadiacion1 = 1:length(R_global1_med_graf);
indiceRadiacion2 = 1:length(R_global2_med_graf);
figure;
plot(indiceRadiacion1, R_global1_med_graf,'g', indiceRadiacion2, R_global2_med_graf,'r');
xlabel('Índice');
ylabel('Radiacion Global Media 1 y 2');
title('Gráfico de Radiacion Global Media 1 y 2');

indiceTemp = 1:length(temp_med_graf);
figure;
plot(indiceTemp, temp_med_graf);
xlabel('Índice');
ylabel('Temperatura ambiente media');
title('Gráfico de Temperatura ambiente media');

% VELOCIDAD DEL VIENTO

indiceVelViento = 1:length(v_viento_med_graf);
figure;
plot(indiceVelViento, v_viento_med_graf);
xlabel('Índice');
ylabel('Velocidad media del viento ');
title('Gráfico de Velocidad media del viento');

% INTENSIDAD LUMINICA FOTOMETROS 1, 2, 3 Y 4

indiceIntLuminica1 = 1:length(Fotometro1_med_graf);
indiceIntLuminica2 = 1:length(Fotometro2_med_graf);
indiceIntLuminica3 = 1:length(Fotometro3_med_graf);
indiceIntLuminica4 = 1:length(Fotometro4_med_graf);
figure;
plot(indiceIntLuminica1, Fotometro1_med_graf,'g', indiceIntLuminica2, Fotometro2_med_graf, 'r', indiceIntLuminica3, Fotometro3_med_graf, 'b', indiceIntLuminica4, Fotometro4_med_graf, 'm');
xlabel('Índice');
ylabel('Intensidad Luminica de todos los fotometros en kLux ');
title('Gráfico de Intensidad Luminica Fotometros 1, 2, 3 y 4');

%HASTA AQUI ME FUNCIONA BIEN SACANDO TODOS LODS DATOS BIEN Y LAS GRAFICAS SALVO LAS FECHAS







